//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "NymWizDlgs.h"
#include "NymRepDlgs.h"
#include "NymRemsDlgs.h"
#include "NymEditDlgs.h"
#include "NymIntrDlgs.h"
#include "NymRestPgpDlgs.h"
#include "NymCnclDlgs.h"
#include "NymMail.h"
#include "pgpbuffers.h"
#include "mixmaster.h"
#include "pgpfiles.h"
#include "FileMan.h"
#include "HeadMan.h"
#include "Global.h"
#include "helpDlgs.h"
#include "view.h";

const int start = 0;
const int nymname = 1;
const int pgpkey = 2;
const int command = 3;
const int blocks = 4;
const int review = 5;
const int Delete = 6;
const int retire = 7;
const int resend = 8;
const int viewnym = 9;
const bool validate = true;
const bool KEYSTOO = true;
const char*Finish = "Finish...";
//---------------------------------------------------------------------------
#pragma link "explbtn"
#pragma resource "*.dfm"
TNymWizDlg *NymWizDlg;
//---------------------------------------------------------------------------
bool __fastcall RunNymWiz(TForm *Owner)
{
   bool run=false;
   NymWizDlg = new TNymWizDlg(Owner);
   CenterDialog(NymWizDlg,Owner);
   NymWizDlg->ShowModal();
   if (NymWizDlg->ModalResult==mrOk) run = true;
   delete NymWizDlg;
   return run;
}
//---------------------------------------------------------------------------
// TNymProfile
//---------------------------------------------------------------------------
__fastcall TNymProfile::TNymProfile()
   : TStringList()
{
}
//---------------------------------------------------------------------------
void __fastcall TNymProfile::setprofile(AnsiString Nym, AnsiString Name,
   AnsiString Commands, AnsiString PgpKey, AnsiString ReplyBlocks,
   AnsiString PublicKey, AnsiString SecretKey)
{
   TStringList *profile = new TStringList();
   profile->Add("Nym: "+Nym);
   profile->Add("Name: "+Name);
   profile->Add("Commands: "+Commands);
   profile->Add("PgpKey: "+PgpKey);
   profile->Add(ReplyBlocks);
   profile->Add(PublicKey);
   profile->Add(SecretKey);
   Text = profile->Text;
   int i=0; while(i<Count)
      if (Strings[i].Trim().IsEmpty()) Delete(i);
      else i++;
   delete profile;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TNymProfile::nym()
{
   int i=0; while(i<Count)
      if (Strings[i].Pos("Nym: ")==1) return Strings[i].SubString(6,128);
      else i++;
   return "";
}
//---------------------------------------------------------------------------
AnsiString __fastcall TNymProfile::nymname()
{
   int i=0; while(i<Count)
      if (Strings[i].Pos("Name: ")==1) return Strings[i].SubString(7,128);
      else i++;
   return "";
}
//---------------------------------------------------------------------------
AnsiString __fastcall TNymProfile::nymcommands()
{
   int i=0; while(i<Count)
      if (Strings[i].Pos("Commands: ")==1) return Strings[i].SubString(11,128);
      else i++;
   return "";
}
//---------------------------------------------------------------------------
AnsiString __fastcall TNymProfile::nympgpkey()
{
   int i=0; while(i<Count)
      if (Strings[i].Pos("PgpKey: ")==1) return Strings[i].SubString(9,128);
      else i++;
   return "";
}
//---------------------------------------------------------------------------
AnsiString __fastcall TNymProfile::nymreplyblocks()
{
   AnsiString blocks;
   bool saving = false;
   TStringList *blks = new TStringList();
   for (int i=0; i<Count; i++)
   {
      if (Strings[i].Pos("-----BEGIN PGP")==1) break;
      if (Strings[i].Pos("Reply-Block:")==1)
      {
         if (!saving) saving = true;
         blks->Add("");
      }
      if (saving) blks->Add(Strings[i]);
   }
   blocks = blks->Text;
   delete blks;
   return blocks;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TNymProfile::nympublickey()
{
// secret key is stored without empty lines at position 2, this must be restored below
   AnsiString key;
   bool saving = false;
   TStringList *lines = new TStringList();
   for (int i=0; i<Count; i++)
   {
      if (Strings[i].Pos("-----BEGIN PGP")==1) saving = true;
      if (saving) lines->Add(Strings[i]);
      if (Strings[i].Pos("-----END PGP")==1) break;
   }
   if (lines->Count>3 && !lines->Strings[2].Trim().IsEmpty()) // restored here
      lines->Insert(2,"");
   key = lines->Text;
   delete lines;
   return key;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TNymProfile::nymsecretkey()
{
   // secret key is stored without empty lines at position 2, this must be restored below
   int keyno = 0;
   AnsiString key;
   bool saving = false;
   TStringList *lines = new TStringList();
   for (int i=0; i<Count; i++)
   {
      if (Strings[i].Pos("-----BEGIN PGP")==1) keyno++;
      if (keyno==2) saving = true;
      if (saving) lines->Add(Strings[i]);
      if (Strings[i].Pos("-----END PGP")==1 && keyno==2) break;
   }
   if (lines->Count>3 && !lines->Strings[2].Trim().IsEmpty()) // restored here
      lines->Insert(2,"");
   key = lines->Text;
   delete lines;
   return key;
}
//---------------------------------------------------------------------------
// TNymWizDlg
//---------------------------------------------------------------------------
__fastcall TNymWizDlg::TNymWizDlg(TComponent* Owner)
  : TForm(Owner)
{
   cap = Caption;
   Application->OnHint = &ShowHint;
   Review->Clear();
   ReplyBlock->Clear();
   ViewProfile->Clear();
   nymcmds = new TStringList();
   userids = new TStringList();
   profile = new TNymProfile();
   nymservers = new TStringList();
   Notebook1->PageIndex = start;

   Caption = "Loading...";
   GetNymServers(nymservers);
   GetNymsAndRetireds();
   cap1 = Label1->Caption;
   NextBtn->Enabled = true; // added so next is enabled when dialog opens
   Timer1->Enabled = true;
   Shifted = false;
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   // 05/17/01
   // this is a temporary task to add Reply-Block templates to older systems
   if (!AppDataExists(NymRBTempsKey))
   {
      TStringList *temps = new TStringList();
      GetAppData(temps,NymRBTempsKey,AppIni);
      if (temps->Count) PutAppData(NymRBTempsKey,temps);
      delete temps;
   }
   // end temp
   ReplayBoxClick(NULL);
   ReinstateBtnClick(NULL);

   key = new TPGPbuffer();
   seckeys = new TPGPbuffer(PgpSecretRing());
   // 05-29-01 removed the onlyusefulkeys to see if users get keys in drop down PGP key box
   pubkeys = new TPGPbuffer(PgpPublicRing()); //pubkeys->onlyusefulkeys();
   remkeys = new TPGPbuffer(PgpRemailRing()); //remkeys->onlyusefulkeys();

   NYM->Left = NYMBox->Left;
   NYM->Top = NYMBox->Top;
   GetAppData(nymcmds,NymCommandsKey);
   SetNymCommands(nymcmds);
   SetNymPgpKeyUserIds();
   NextBtn->Enabled = true;
   LoadCpkDirectivesMenu();
   LoadCpkHeadersMenu();
   LoadRBTemplatesMenu();
   LoadRemailersMenu();
   Caption = cap;

   AnsiString lastnym = GetAppIni(LastNymProfileKey,"");
   NYMBox->ItemIndex = NYMBox->Items->IndexOf(lastnym);
   if (!NYMBox->Text.IsEmpty()) SetInputFromNym(NYMBox->Text);
   if (NYMSHOWINTRO && ShowNymIntroHelp(this)==false)
      NYMSHOWINTROSET("0");
   NymsDeleteBox->ItemIndex = NymsDeleteBox->Items->IndexOf(lastnym);
   NymsResendBox->ItemIndex = NymsResendBox->Items->IndexOf(lastnym);
}
//---------------------------------------------------------------------------
__fastcall TNymWizDlg::~TNymWizDlg()
{
   delete remkeys;
   delete pubkeys;
   delete seckeys;
   delete profile;
   delete userids;
   delete nymcmds;
   delete key;
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::ShowHint(TObject *Sender)
{
   ((TForm*)Owner)->Perform(WM_SHOWSTATUS,0,(LPARAM)Application->Hint.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::GetNymsAndRetireds()
{
   TStringList *nyms = new TStringList();
   GetAppData(nyms,NymProfilesKey);

   if (nyms->Count) NYMBox->Items->Text = nyms->Text;
   else ModifyBtn->Enabled = false;

   if (nyms->Count) NymsDeleteBox->Items->Text = nyms->Text;
   else DeleteBtn->Enabled = false;

   if (nyms->Count) ViewNym->Items->Text = nyms->Text;
   else ViewNymBtn->Enabled = false;

   GetAppData(nyms,NymRetiredsKey);

   if (nyms->Count) NymsRetireBox->Items->Text = nyms->Text;
   else RetiredBtn->Enabled = false;

   GetAppData(nyms,NymReplaysKey);
   if (nyms->Count) NymsResendBox->Items->Text = nyms->Text;
   else ResendBtn->Enabled = false;

   delete nyms;
}
//---------------------------------------------------------------------------
AnsiString __fastcall spcs(int count)
{
   AnsiString spc;
   return spc.StringOfChar(' ',count);
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::LoadRemailersMenu()
{
   while (PopupRemMenu->Items->Count>0)
      PopupRemMenu->Items->Delete(PopupRemMenu->Items->Count-1);
   // list of remailer caps strings in form shortname=caps string
   AnsiString shrt,line,caps,cap;
   TStringList *remcaps,*remperf,*rems,*tmp;
   tmp = new TStringList();
   rems = new TStringList();
   remcaps = new TStringList();
   remperf = new TStringList();
   if (FileExists(clisttxt)) tmp->LoadFromFile(clisttxt);
   for (int i=0; i<tmp->Count; i++)
   {
      line = tmp->Strings[i];
      if (line.Pos("$remailer{")==1)
      {
         shrt = GetToken(1,line,"\"");
         caps = GetToken(3,line,"\"");
         remcaps->Add(shrt+"="+GetToken(1,caps,">").Trim());
      }
      else
      if (line.Pos("%")==line.Length())
      {
         shrt = GetToken(0,line," ");
         remperf->Add(shrt+"=HISTORY: "+line.SubString(line.Length()-29,30));
         rems->Add(shrt);
      }
   }
   for (int i=0; i<rems->Count; i++)
   {
      shrt = rems->Strings[i];
      cap = shrt+"\t"+remperf->Values[shrt];
      if (shrt.Trim().IsEmpty()) continue;
      TMenuItem *item = new TMenuItem(this);
      item->OnClick = PopupMenuItemOnClick;
      item->Caption = shrt; //cap;
      item->Hint = remcaps->Values[shrt];//+"   "+remperf->Values[shrt];
      PopupRemMenu->Items->Add(item);
      //if (i==rems->Count/2) item->Break = mbBarBreak;
   }
   delete remperf;
   delete remcaps;
   delete rems;
   delete tmp;
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::PopupMenuItemOnClick(TObject *Sender)
{
   TMenuItem *item;
   if ((item=dynamic_cast<TMenuItem*>(Sender))==NULL) return;
   AnsiString cap = item->Caption;
   if (cap.Length() && cap[cap.Length()]==':') cap += " ";
   else cap += "\r\n";
   ReplyBlock->SelText = cap;
   ActiveControl = ReplyBlock;
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::LoadCpkDirectivesMenu()
{
   while (PopupDirMenu->Items->Count>2)
      PopupDirMenu->Items->Delete(PopupDirMenu->Items->Count-1);
   TStringList *dirs = new TStringList();
   GetCpkDirectives(dirs);
   for (int i=0; i<dirs->Count; i++)
   {
      if (dirs->Strings[i].Trim().IsEmpty()) continue;
      TMenuItem *item = new TMenuItem(this);
      item->OnClick = PopupMenuItemOnClick;
      item->Caption = dirs->Strings[i].Trim();
      PopupDirMenu->Items->Add(item);
   }
   delete dirs;
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::LoadCpkHeadersMenu()
{
   while (PopupHdrMenu->Items->Count>2)
      PopupHdrMenu->Items->Delete(PopupHdrMenu->Items->Count-1);
   TStringList *hdrs = new TStringList();
   GetCpkHeaders(hdrs);
   for (int i=0; i<hdrs->Count; i++)
   {
      if (hdrs->Strings[i].Trim().IsEmpty()) continue;
      TMenuItem *item = new TMenuItem(this);
      item->OnClick = PopupMenuItemOnClick;
      item->Caption = hdrs->Strings[i].Trim();
      PopupHdrMenu->Items->Add(item);
   }
   delete hdrs;
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::PopupRBTempItemOnClick(TObject *Sender)
{
   TMenuItem *item;
   if ((item=dynamic_cast<TMenuItem*>(Sender))==NULL) return;
   ReplyBlock->Clear(); AppProcessMessages();
   SetRedraw(ReplyBlock,0); Sleep(200);

   bool saving = false;
   TStrings *rb = ReplyBlock->Lines;
   AnsiString line,name = item->Caption;
   TStringList *temps = new TStringList();
   GetAppData(temps,NymRBTempsKey);
   for (int i=0; i<temps->Count; i++)
   {
      line = temps->Strings[i];
      if (line=="["+name+"]")
      {
         saving = true;
         continue;
      }
      if (saving && line.Pos("[")==1) break;
      if (saving) rb->Add(line);
   }
   TrimNulls(rb);
   //while (rb->Count && rb->Strings[0].Trim().IsEmpty()) rb->Delete(0);
   //while (rb->Count && rb->Strings[rb->Count-1].Trim().IsEmpty())
   //   rb->Delete(rb->Count-1);
   ActiveControl = ReplyBlock;
   ReplyBlock->SelStart = 0;
   AppProcessMessages();
   SetRedraw(ReplyBlock,1);
   delete temps;
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::LoadRBTemplatesMenu()
{
   AnsiString line;
   TStringList *tmps = new TStringList();
   while (PopupTmpMenu->Items->Count>2)
      PopupTmpMenu->Items->Delete(PopupTmpMenu->Items->Count-1);
   GetAppData(tmps,NymRBTempsKey);
   for (int i=0; i<tmps->Count; i++)
   {
      line = tmps->Strings[i];
      if (line.IsEmpty() || line[1]!='[') continue;
      TMenuItem *item = new TMenuItem(this);
      item->OnClick = PopupRBTempItemOnClick;
      item->Caption = line.SubString(2,line.Length()-2);
      PopupTmpMenu->Items->Add(item);
   }
   delete tmps;
}
//---------------------------------------------------------------------------
AnsiString __fastcall DefaultReplyBlock()
{
   bool saving = false;
   AnsiString block,line;
   TStringList *rb = new TStringList();
   TStringList *temps= new TStringList();
   GetAppData(temps,NymRBTempsKey);
   for (int i=0; i<temps->Count; i++)
   {
      line = temps->Strings[i];
      if (line.TrimLeft().Pos("[")==1 && !saving)
      {
         saving = true;
         continue;
      }
      if (saving && line.TrimLeft().Pos("[")==1) break;
      if (saving) rb->Add(line);
   }
   TrimNulls(rb);
   block = rb->Text;
   delete temps;
   delete rb;
   return block;
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::ClearAll()
{
   NYM->Clear();
   Name->Clear();
   NYMBox->ItemIndex = -1;
   PgpKey->ItemIndex = -1;
   ReplyBlock->Clear();
   ReplyBlock->Lines->Text = DefaultReplyBlock();
   Review->Clear();
   profile->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::GetPublicsFromSecrets(TPGPbuffer *pubs)
{
   pubs->clear();
   seckeys->rewind();
   TPGPbuffer *key = new TPGPbuffer();
   TPGPbuffer *pub = new TPGPbuffer();
   while (key->copykeyfrom(seckeys))
   {
      if (SecretKeyPacket(key->CTB) && pubkeys->get(key->idtext8,pub))
         pubs->copyfrom(pub);
      key->clear();
   }
   pubs->onlyusefulkeys();
   seckeys->rewind();
   delete key;
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::SetNymPgpKeyUserIds()
{
   AnsiString idtext8;
   PgpKey->Clear();
   key->clear();
   seckeys->rewind();
   TPGPbuffer *pubs = new TPGPbuffer();
   GetPublicsFromSecrets(pubs);
   while (key->copykeyfrom(pubs,REWIND))
   {
      if (key->algostr=="RSA" && key->bits<=2048)
      {
         TStringList *ids = new TStringList();
         key->getuserids(ids);
         for (int i=0; i<ids->Count; i++)
            PgpKey->Items->Add("0x"+key->idtext8+"  "+ids->Strings[i]);
         delete ids;
      }
      key->clear();
   }
   delete pubs;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TNymWizDlg::GetPgpPubKeyIdText8(AnsiString &userid)
{
   AnsiString idtext8;
   key->clear();
   remkeys->rewind();
   while (key->copykeyfrom(remkeys,REWIND))
   {
      if (!key->revoked && !key->expired && key->enabled && key->hasuserid(userid))
      {
         idtext8 = key->idtext8;
         break;
      }
      key->clear();
   }
   if (idtext8.IsEmpty())
      MsgBoxHwnd(Handle,"Unable to find a PGP key for: "+userid+"!","Information",MB_OK);
   return idtext8;
}
//---------------------------------------------------------------------------
bool __fastcall validaddress(AnsiString addr)
{
   int pos = addr.Pos("@");
   return pos>1 && addr.SubString(pos,256).Pos(".");
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::FillReviewFromInput()
{
   Review->Lines->Clear();
   Review->Lines->Add("Nym: "+NYM->Text);
   Review->Lines->Add("");
   Review->Lines->Add("Name: "+Name->Text);
   Review->Lines->Add("");
   Review->Lines->Add("Commands: "+NymCommandsStr());
   Review->Lines->Add("");
   Review->Lines->Add("PgpKey: "+PgpKey->Text);
   Review->Lines->Add("");
   Review->Lines->AddStrings(ReplyBlock->Lines);
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::GenProfileFromInput(TStrings *profile)
{
   profile->Clear();
   profile->Add("Nym: "+NYM->Text);
   profile->Add("Name: "+Name->Text);
   profile->Add("Commands: "+NymCommandsStr());
   profile->Add("PgpKey: "+PgpKey->Text);
   profile->AddStrings(ReplyBlock->Lines);
   AnsiString keyid = PgpKey->Text.SubString(3,8);
   if (pubkeys->get(keyid,key)) profile->Add(key->export());
   if (seckeys->get(keyid,key)) profile->Add(key->export());
   profile->Text = profile->Text;
   int i=0; while (i<profile->Count)
   {
      if (profile->Strings[i].Trim().IsEmpty()) profile->Delete(i);
      else i++;
   }
}
//---------------------------------------------------------------------------
AnsiString __fastcall TNymWizDlg::EmailAddress()
{
   AnsiString address=NYM->Text;
   if (!Name->Text.Trim().IsEmpty())
   {
      if (address.SubString(address.Length(),1)!=">") address += ">";
      if (address.SubString(1,1)!="<") address = "<"+address;
      address = Name->Text+" "+address;
   }
   return address;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TNymWizDlg::PgpKeyUserId()
{
   return PgpKey->Text.SubString(13,256);
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::GetPgpKeyFromEmailAddress()
{
   for (int i=0; i<PgpKey->Items->Count; i++)
     if (PgpKey->Items->Strings[i].Pos(EmailAddress()))
        PgpKey->ItemIndex = i;
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::SetFingerKeyFromInput()
{
   for (int i=0; i<nymcmds->Count; i++)
   {
      AnsiString nymaddr = nymcmds->Strings[i].SubString(2,256);
      if (nymaddr!="fingerkey") continue;

      TCheckBox *chkbox = (TCheckBox*)(nymcmds->Objects[i]);
      if (PgpKey->Text.Pos("<"+NYM->Text+">")>0) chkbox->Enabled = true;
      else
      {
         chkbox->Enabled = false;
         chkbox->Checked = false;
      }
   }
}
//---------------------------------------------------------------------------
AnsiString __fastcall TNymWizDlg::NymCommandsStr(int breakAt)
{
   AnsiString str;
   for (int i=0; i<nymcmds->Count; i++)
   {
      TCheckBox *chkbox = dynamic_cast<TCheckBox*>(nymcmds->Objects[i]);
      if (chkbox) str += (chkbox->Checked?" +":" -")+chkbox->Caption;
      if (i==breakAt) str += "\r\n ";
   }
   return str.TrimLeft();
}
//---------------------------------------------------------------------------
AnsiString __fastcall TNymWizDlg::NymServerKeyIdText8()
{
   return GetPgpPubKeyIdText8("config@"+GetToken(1,NYM->Text,"@"));
}
//---------------------------------------------------------------------------
AnsiString __fastcall TNymWizDlg::NymKeyIdText8()
{
   return PgpKey->Text.SubString(3,8);
}
//---------------------------------------------------------------------------
bool __fastcall validreplyblock(TMemo *block)
{
   TrimNullsBefore(block->Lines);
   return block->Lines->Text.Pos("Reply-Block:")==1;
}
//---------------------------------------------------------------------------
bool __fastcall TNymWizDlg::CreateNymCreateMessage(TStrings *msg)
{
   bool ok;
   msg->Clear();
   TStringList *lines = new TStringList();
   key->clear();
   remkeys->rewind();
   AnsiString nymserver = "config@"+GetToken(1,NYM->Text,"@");
   if ((ok=remkeys->hasuserid(nymserver))==true)
   {
      pubkeys->rewind();
      if ((ok=pubkeys->get(NymKeyIdText8(),key))==true)
      {
         key->export(msg);
         msg->Insert(0,"Config:");
         msg->Insert(1,"From: "+GetToken(0,NYM->Text,"@"));
         msg->Insert(2,"Nym-Commands: create? name=\""+Name->Text+"\" "+NymCommandsStr());
         msg->Insert(3,"Public-Key:");
         if ((ok=GenerateReplyBlocks(this,lines,ReplyBlock->Lines))==true)
            msg->AddStrings(lines);
         else
            MsgBoxHwnd(Handle,"Unable to generate reply block(s)",
               "PGP Key Error",MB_OK);
      }
      else
         MsgBoxHwnd(Handle,"Unable to locate PGP key: 0x"+NymKeyIdText8(),
            "PGP Key Error",MB_OK);
   }
   else
      MsgBoxHwnd(Handle,"No PGP key for "+nymserver+"!",
         "PGP Key Error",MB_OK);

   msg->Insert(0,"To: config@"+GetToken(1,NYM->Text,"@"));
   msg->Insert(1,"");
   TrimNullsEnd(msg);
   msg->Add("~~");
   delete lines;
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TNymWizDlg::PrepareNymCreateMessage()
{
  if (MsgBoxHwnd(Handle,"Generate nym-config message now?","Confirm",MB_OKCANCEL)==IDOK)
  {
     AnsiString atohdr,pgphdr,tempname;
     // get template to use with message
     TStringList *temps = new TStringList();
     GetAppData(temps,UserTemplates);
     if (temps->IndexOf("nym-config")>=0) tempname=UserTemplates+PS+"nym-config";
     delete temps;
     if (tempname.IsEmpty()) tempname = GetMergeMessage(
        "Select a template for your nym-config message",modeNymcnfg
     );
     if (tempname.IsEmpty()) return false;

     TStringList *msg = new TStringList();
     if (!CreateNymCreateMessage(msg))
     {
        delete msg; return false;
     }

     THeaderManager *headman = new THeaderManager(msg);
     // create a pgp header and get To: header from message
     pgphdr = s(PgpHdr)+"sign=0x"+NymKeyIdText8()+"; encrypt=0x"+NymServerKeyIdText8();
     atohdr = msg->Strings[0]; msg->Delete(0);
     // get template
     TStringList *Template = new TStringList();
     GetAppData(Template,tempname);
     // insert all lines into top of message
     int pos,eoh=0; while(eoh<Template->Count)
     {
        // break after headers
        if (Template->Strings[eoh].Trim().IsEmpty()) break;
        msg->Insert(eoh,Template->Strings[eoh]);
        eoh++;
     }
     // delete the To: header stub and insert real To: same line
     pos = headman->Delete("To: ");
     if (pos<0) pos = eoh;
     msg->Insert(pos,atohdr);
     // delete Pgp: header stub and insert as above
     pos = headman->Delete(PgpHdr);
     if (pos<0) pos = eoh;
     msg->Insert(pos,pgphdr);
     delete Template;

     msg->Insert(0,NymConfigHdr+NYM->Text);

     // save this message with previous placed in old profiles
     TStringList *profile = new TStringList();
     GetAppData(profile,NymProfilesKey+PS+NYM->Text);
     if (profile->Count) PutAppData(NymProfOldsKey+PS+NYM->Text,profile);
     GenProfileFromInput(profile);
     PutAppData(NymProfilesKey+PS+NYM->Text,profile);
     delete profile;
     delete headman;

     PutNymMessageOnDesktop(msg); delete msg;
     RetiredBtn->Enabled = AppDataExists(NymRetiredsKey);
     ModifyBtn->Enabled = true;
     ResendBtn->Enabled = true;
     DeleteBtn->Enabled = true;
     StepClose();
   }
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TNymWizDlg::CreateNymModifyMessage(TStrings *msg)
{
   bool ok;
   msg->Clear();
   TStringList *lines = new TStringList();
   key->clear();
   remkeys->rewind();
   AnsiString nymserver = "config@"+GetToken(1,NYM->Text,"@");
   if ((ok=remkeys->hasuserid(nymserver))==true)
   {
      pubkeys->rewind();
      if ((ok=pubkeys->get(NymKeyIdText8(),key))==true)
      {
         msg->Add("Config:");
         msg->Add("From: "+GetToken(0,NYM->Text,"@"));
         msg->Add("Nym-Commands: create? name=\""+Name->Text+"\" "+NymCommandsStr());
         if (profile->nympgpkey()!=PgpKey->Text || ReplyBlock->Modified)
         {
            key->export(msg);
            msg->Insert(0,"Public-Key:");
         }
         if (ReplyBlock->Modified)
         {
            if ((ok=GenerateReplyBlocks(this,lines,ReplyBlock->Lines))==true)
               msg->AddStrings(TrimNullsBefore(lines));
            else
               MsgBoxHwnd(Handle,"Unable to generate reply block(s)",
                  "PGP Key Error",MB_OK);
         }
      }
      else
         MsgBoxHwnd(Handle,"Unable to locate PGP key: 0x"+NymKeyIdText8(),
            "PGP Key Error",MB_OK);
   }
   else
      MsgBoxHwnd(Handle,"No PGP key for "+nymserver+"!",
         "PGP Key Error",MB_OK);

   msg->Insert(0,"To: config@"+GetToken(1,NYM->Text,"@"));
   msg->Insert(1,"");
   msg->Add("~~");
   delete lines;
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TNymWizDlg::PrepareNymModifyMessage()
{
  if (MsgBoxHwnd(Handle,"Generate nym-config message now?","Confirm",MB_OKCANCEL)==IDOK)
  {
     AnsiString curidtext8,atohdr,pgphdr,tempname;
     // get template to use with message
     TStringList *temps = new TStringList();
     GetAppData(temps,UserTemplates);
     if (temps->IndexOf("nym-config")>=0) tempname=UserTemplates+PS+"nym-config";
     delete temps;
     if (tempname.IsEmpty()) tempname = GetMergeMessage(
        "Select a template for your nym-config message",modeNymcnfg
     );
     if (tempname.IsEmpty()) return false;

     TStringList *msg = new TStringList();
     if (!CreateNymModifyMessage(msg))
     {
        delete msg; return false;
     }

     THeaderManager *headman = new THeaderManager(msg);
     // sign with profile key--in case user has changed pgp keys
     curidtext8 = profile->nympgpkey().SubString(3,8);
     // create a pgp header and get To: header from message
     pgphdr = s(PgpHdr)+"sign=0x"+curidtext8+"; encrypt=0x"+NymServerKeyIdText8();
     atohdr = msg->Strings[0]; msg->Delete(0);
     // get template
     TStringList *Template = new TStringList();
     GetAppData(Template,tempname);
     // insert all lines into top of message
     int pos,eoh=0; while(eoh<Template->Count)
     {
        // break after headers
        if (Template->Strings[eoh].Trim().IsEmpty()) break;
        msg->Insert(eoh,Template->Strings[eoh]);
        eoh++;
     }
     // delete the To: header stub and insert real To: same line
     pos = headman->Delete("To: ");
     if (pos<0) pos = eoh;
     msg->Insert(pos,atohdr);
     // delete Pgp: header stub and insert as above
     pos = headman->Delete(PgpHdr);
     if (pos<0) pos = eoh;
     msg->Insert(pos,pgphdr);
     delete Template;

     msg->Insert(0,NymConfigHdr+NYM->Text);
     // save this message with previous placed in old profiles
     TStringList *Profile = new TStringList();
     GetAppData(Profile,NymProfilesKey+PS+NYM->Text);
     if (Profile->Count) PutAppData(NymProfOldsKey+PS+NYM->Text,Profile);
     GenProfileFromInput(profile);
     PutAppData(NymProfilesKey+PS+NYM->Text,profile);
     delete Profile;
     delete headman;

     PutNymMessageOnDesktop(msg); delete msg;
     RetiredBtn->Enabled = AppDataExists(NymRetiredsKey);
     ModifyBtn->Enabled = true;
     ResendBtn->Enabled = true;
     DeleteBtn->Enabled = true;
     StepClose();
   }
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TNymWizDlg::CreateNymDeleteMessage(TStrings *msg)
{
   bool ok;
   msg->Clear();
   TStringList *lines = new TStringList();
   key->clear();
   remkeys->rewind();
   AnsiString nymserver = "config@"+GetToken(1,NYM->Text,"@");
   if ((ok=remkeys->hasuserid(nymserver))==true)
   {
      pubkeys->rewind();
      if ((ok=pubkeys->get(NymKeyIdText8(),key))==true)
      {
         msg->Add("Config:");
         msg->Add("From: "+GetToken(0,NYM->Text,"@"));
         msg->Add("Nym-Commands: delete");
         msg->Add("");
      }
      else
         MsgBoxHwnd(Handle,"Unable to locate PGP key: 0x"+NymKeyIdText8(),
            "PGP Key Error",MB_OK);
   }
   else
      MsgBoxHwnd(Handle,"No PGP key for "+nymserver+"!",
         "PGP Key Error",MB_OK);

   msg->Insert(0,"To: config@"+GetToken(1,NYM->Text,"@"));
   msg->Insert(1,"");
   TrimNullsEnd(msg);
   msg->Add("~~");
   delete lines;
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TNymWizDlg::PrepareNymDeleteMessage()
{
  if (MsgBoxHwnd(Handle,"Generate nym-delete message now?","Confirm",MB_OKCANCEL)==IDOK)
  {
     AnsiString atohdr,pgphdr,tempname;
     // get template to use with message
     TStringList *temps = new TStringList();
     GetAppData(temps,UserTemplates);
     if (temps->IndexOf("nym-config")>=0) tempname=UserTemplates+PS+"nym-config";
     delete temps;
     if (tempname.IsEmpty()) tempname = GetMergeMessage(
        "Select a template for your nym-config message",modeNymcnfg
     );
     if (tempname.IsEmpty()) return false;

     TStringList *msg = new TStringList();
     if (!CreateNymDeleteMessage(msg))
     {
        delete msg; return false;
     }

     THeaderManager *headman = new THeaderManager(msg);
     // create a pgp header and get To: header from message
     pgphdr = s(PgpHdr)+"sign=0x"+NymKeyIdText8()+"; encrypt=0x"+NymServerKeyIdText8();
     atohdr = msg->Strings[0]; msg->Delete(0);
     // get template
     TStringList *Template = new TStringList();
     GetAppData(Template,tempname);
     // insert all lines into top of message
     int pos,eoh=0; while(eoh<Template->Count)
     {
        // break after headers
        if (Template->Strings[eoh].Trim().IsEmpty()) break;
        msg->Insert(eoh,Template->Strings[eoh]);
        eoh++;
     }
     // delete the To: header stub and insert real To: same line
     pos = headman->Delete("To: ");
     if (pos<0) pos = eoh;
     msg->Insert(pos,atohdr);
     // delete Pgp: header stub and insert as above
     pos = headman->Delete(PgpHdr);
     if (pos<0) pos = eoh;
     msg->Insert(pos,pgphdr);
     delete Template;
     delete headman;

     msg->Insert(0,NymConfigHdr+NYM->Text);

     // remove this nym from profiles, put it in retired basket
     TStringList *profile = new TStringList();
     GetAppData(profile,NymProfilesKey+PS+NYM->Text);
     PutAppData(NymRetiredsKey+PS+NYM->Text,profile);
     PutAppData(NymProfilesKey+PS+NYM->Text,NULL);
     PutAppData(NymProfOldsKey+PS+NYM->Text,NULL);
     PutAppData(NymConfigsKey+PS+NYM->Text,NULL);
     PutAppData(NymReplaysKey+PS+NYM->Text,NULL);
     delete profile;

     PutNymMessageOnDesktop(msg); delete msg;
     bool gotprofs = AppDataExists(NymProfilesKey);
     ModifyBtn->Enabled = gotprofs;
     ResendBtn->Enabled = gotprofs;
     DeleteBtn->Enabled = gotprofs;
     RetiredBtn->Enabled = true;
     AppProcessMessages(); Sleep(100);
     Notebook1->ActivePage = start;
     StepClose();
   }
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TNymWizDlg::PrepareNymResendMessage()
{
  AnsiString confirm_msg,atohdr,pgphdr,tempname;
  bool replay = ReplayBox->Checked;
  if (replay) confirm_msg = "Open nym-config replay message now?";
  else confirm_msg = "Open nym-config message now?";

  if (MsgBoxHwnd(Handle,confirm_msg,"Confirm",MB_OKCANCEL)==IDOK)
  {
     TStringList *msg = new TStringList();
     AnsiString msgkey = ReplayBox->Checked ? NymReplaysKey : NymConfigsKey;
     GetAppData(msg,msgkey+PS+NymsResendBox->Items->Strings[NymsResendBox->ItemIndex]);
     int i=0; while(i<msg->Count)
     {
        if (msg->Strings[i].Trim().IsEmpty()) break;
        if (msg->Strings[i].Pos("To: ")==0) msg->Delete(i);
        else i++;
     }

     // get template to use with message
     TStringList *temps = new TStringList();
     GetAppData(temps,UserTemplates);
     if (temps->IndexOf("nym-config")>=0) tempname=UserTemplates+PS+"nym-config";
     delete temps;
     if (tempname.IsEmpty()) tempname = GetMergeMessage(
        "Select a template for your nym-config message",modeNymcnfg
     );
     if (tempname.IsEmpty()) return false;

     // create a pgp header and get To: header from message
     pgphdr = s(PgpHdr)+"sign=0x"+NymKeyIdText8()+"; encrypt=0x"+NymServerKeyIdText8();
     atohdr = msg->Strings[0]; msg->Delete(0);

     // get template
     TStringList *Template = new TStringList();
     GetAppData(Template,tempname);
     // insert all lines into top of message
     int pos,eoh=0; while(eoh<Template->Count)
     {
        // break after headers
        if (Template->Strings[eoh].Trim().IsEmpty()) break;
        msg->Insert(eoh,Template->Strings[eoh]);
        eoh++;
     }

     THeaderManager *headman = new THeaderManager(msg);
     // delete the To: header stub and insert real To: same line
     pos = headman->Delete("To: ");
     msg->Insert(pos<0?eoh:pos,atohdr);
     // delete Pgp: header stub and insert as above
     pos = headman->Delete(PgpHdr);
     // insert as above, if NOT a replay
     if (!replay) msg->Insert(pos<0?eoh:pos,pgphdr);
     delete Template;
     delete headman;

     if (!replay) msg->Insert(0,NymConfigHdr+NYM->Text);
     PutNymMessageOnDesktop(msg); delete msg;
     StepClose();
   }
   return true;
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::ReinstateNymInSystem()
{
   PrepareNymCreateMessage();
   PutAppData(NymRetiredsKey+PS+NYM->Text,NULL);
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::RemoveNymFromSystem()
{
   if (MsgBoxHwnd(Handle,
      "Delete this retired nym from the system?",
      "Confirm",MB_OKCANCEL)==IDOK
       &&
       MsgBoxHwnd(Handle,
      "Are you sure you want to delete this nym?",
      "Confirm",MB_OKCANCEL)==IDOK)
   {
      AppProcessMessages(); Sleep(50);
      AnsiString nym = NymsRetireBox->Items->Strings[NymsRetireBox->ItemIndex];
      PutAppData(NymRetiredsKey+PS+nym,NULL);
      GetAppData(NymsRetireBox->Items,NymRetiredsKey);
      StepClose();
   }
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::SendNymDeleteAgain()
{
   PrepareNymDeleteMessage();
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::StepClose()
{
   Notebook1->Visible = false;
   AppProcessMessages(); Sleep(100);
   CancelBtn->Caption = "Close";
   NextBtn->Caption = "Next";
   Notebook1->PageIndex = 0;
   Notebook1->Visible = true;
   AppProcessMessages(); Sleep(200);
   ModalResult = mrOk;
}
//---------------------------------------------------------------------------
AnsiString eaddr(AnsiString &userid)
{
   int s,e,at=userid.Pos("@");
   if (at>1)
   {
      AnsiString addr,terms = "< >=,\r\n";
      s = at-1; while(s>0 && terms.Pos(userid[s])<1) s--;
      e = at+1; while(e<=userid.Length() && terms.Pos(userid[e])<1) e++;
      return userid.SubString(s+1,e-1-s);
   }
   return "";
}
//---------------------------------------------------------------------------
void __fastcall FlagLine(int &errs, int lineno, TStrings *lines, AnsiString errmsg)
{
   if (lineno>=0 && lineno<lines->Count)
   {
      AnsiString line;
      Graphics::TBitmap *bmp = new Graphics::TBitmap();
      line = lines->Strings[lineno];
      while (bmp->Canvas->TextWidth(line)<200) line += " ";
      lines->Strings[lineno] = line+"  <---  "+errmsg;
      delete bmp;
   }
   errs++;
}
//---------------------------------------------------------------------------
bool __fastcall TNymWizDlg::ReplyBlocksValid(TForm *Owner, TStrings *block)
{
   SetRedraw(this,0);
   int pos,leg,errs=0;
   AnsiString line,label,addr,rem;
   TList *bads = new TList();
   TStringList *dirs = new TStringList();
   TStringList *hdrs = new TStringList();
   TStringList *rems = new TStringList();
   TStringList *longs = new TStringList();
   TStringList *shrts = new TStringList();
   GetCpkRemailerShortsEqualLongs(rems);
   GetCpkRemailerShorts(shrts,rems);
   GetCpkRemailerLongs(longs,rems);
   GetCpkDirectives(dirs);
   GetCpkHeaders(hdrs);
   // remove previous error flags
   for (int i=0; i<block->Count; i++)
   {
      rem = block->Strings[i];
      if ((pos=rem.Pos("<---"))>0)
         block->Strings[i] = rem.SubString(1,pos-1).TrimRight();
   }
   // dump null lines
   TrimNulls(block);
   while (block->Count && block->Strings[0].Trim().Pos("Reply-Block:")!=1)
      block->Delete(0);
   block->Insert(0,"");
   block->Add(""); // add for tripping leg 0 at end of blocks

   // check all lines individually no matter the count
   for (int i=block->Count-1; i>0; i--)
   {
      line = block->Strings[i].Trim();
      if (line.IsEmpty()) // end of reply block
      {
         leg = 0; i--; continue;
      }

      if (line.Pos(":")==0)
      {
         // this line is not a directive so it must be a user or remailer name/address
         if (leg>0 && shrts->IndexOf(line)<0 && longs->IndexOf(line)<0)
            FlagLine(errs,i,block,"Unknown remailer");
         leg++;
      }
      else
      {
         // there is at lease a directive or header (could be just "Reply-Block:")
         label = GetToken(0,line," ");
         if (dirs->IndexOf(label)<0 && hdrs->IndexOf(label)<0)
            FlagLine(errs,i,block,"Unknown directive");
         else
         {
            if (label.Pos("-To:")) // this line will have a name or address
            {
               addr = GetToken(1,line," ");
               if (leg>0 && shrts->IndexOf(addr)<0 && longs->IndexOf(addr)<0)
                  FlagLine(errs,i,block,"Unknown remailer");
            }
         }
      }
   }
   TrimNulls(block);
   delete shrts;
   delete longs;
   delete rems;
   delete hdrs;
   delete dirs;
   delete bads;
   bool baddir = block->Text.Pos("Unknown directive")>0;
   bool badrem = block->Text.Pos("Unknown remailer")>0;
   AnsiString badremmsg,baddirmsg,errormsg;
   badremmsg =
      s("I have discovered 1 or more unknown remailers in your reply block.\n")+
      s("I'll flag the line(s). Please have a look. You probably have a typo!");
   baddirmsg =
      s("I have discovered 1 or more unknown directives (or headers) in\n")+
      s("your reply block. I'll flag the line(s). Please have a look. You may\n")+
      s("have a typo.\n\n")+
      s("If you are using a directive that is not on the editor Directives Menu,\n")+
      s("or a message header not on the Headers Menu, see the Help topic\n")+
      s("'Directives and Header Requirements'.");
   errormsg = (badrem ? badremmsg : s(""))+(badrem && baddir ? "\n\n" : "")+
      (baddir ? baddirmsg : s(""));
   if (errs) MsgBoxHwnd(Owner->Handle,errormsg,"Reply Block Error",MB_OK);
   SetRedraw(this,1);
   return !baddir && !badrem;
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::PutNymMessageOnDesktop(TStrings *msg)
{
   ((TForm*)Owner)->Perform(WM_OPENNYMMESSAGE,0,(LPARAM)msg->Text.c_str());
}
//---------------------------------------------------------------------------
AnsiString __fastcall TNymWizDlg::GetMergeMessage(AnsiString &caption, int mode)
{
   return (char*)((TForm*)Owner)->Perform(WM_GETMERGEMESSAGE,mode,
      (LPARAM)caption.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::SetLabel1Caption(AnsiString Cap)
{
   Label1->Caption = Cap;
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::NextBtnClick(TObject *Sender)
{
  int idx=Notebook1->PageIndex;
  AnsiString addr,keyline,line,hdr,uid,domain;
  if ((NextBtn->Caption==Finish || (Notebook1->PageIndex==nymname && ModifyBtn->Checked)) &&
     !CheckNymPgpKeyNotMissing()) return;

  if (idx==review || idx==resend || idx==Delete || idx==retire)
  {
     switch (idx)
     {
        case review:
           if (CreateBtn->Checked) PrepareNymCreateMessage();
           else PrepareNymModifyMessage();
           break;
        case Delete: PrepareNymDeleteMessage(); break;
        case resend: PrepareNymResendMessage(); break;
        case retire:
           if (ReinstateBtn->Checked) ReinstateNymInSystem(); else
           if (RemoveBtn->Checked) RemoveNymFromSystem(); else
           if (ReDelBtn->Checked) SendNymDeleteAgain();
     }
     return;
  }
  if (idx==start)
  {
     if (CreateBtn->Checked)
     {
        ClearAll();
        TPGPbuffer *key = new TPGPbuffer();
        TPGPbuffer *pubs = new TPGPbuffer();
        GetPublicsFromSecrets(pubs);
        while (key->copykeyfrom(pubs,REWIND))
        {
           if (key->algostr=="RSA" && key->bits<=2048)
           {
              userids->Add(key->getuserids());
           }
           key->clear();
        }
        delete pubs;
        delete key;
        userids->Text = userids->Text; // reassemble for adding multi-lines as single, above
        for (int i=0; i<userids->Count; i++)
        {
           uid = userids->Strings[i].Trim();
           if (uid.IsEmpty()) continue;

           addr = eaddr(uid);
           if (nymservers->IndexOf(GetToken(1,addr,"@"))<0) continue;
           // only addresses with nymserver domains get here
           if (NYM->Items->IndexOf(addr)<0) NYM->Items->Add(addr);
        }
        int i=0; while(i<NYM->Items->Count)
        {
           if (NYMBox->Items->IndexOf(NYM->Items->Strings[i])<0) i++;
           else NYM->Items->Delete(i);
        }
        CancelBtn->Caption = "Cancel";
        Caption = cap + " - Create Nym";
        NYM->Visible = true;
        NYMBox->Visible = false;
        BackBtn->Enabled = true;
        NextBtn->Enabled = true;
        Notebook1->PageIndex++;
        Label5->Caption =
           "Type in, or select from the drop-down list, the e-mail address for your nym.";
        Label7->Caption = "&Nym ( ex: jsmith@nym.alias.net )";
        ActiveControl = NYM;
        return;
     }

     if (ModifyBtn->Checked)
     {
        if (NYMBox->Text.IsEmpty()) ClearAll();
        CancelBtn->Caption = "Cancel";
        Caption = cap +" - Modify Nym";
        NYM->Visible = false;
        NYMBox->Visible = true;
        BackBtn->Enabled = true;
        NextBtn->Enabled = true;
        Notebook1->PageIndex++;
        Label5->Caption = "Select the nym you wish to modify from the drop-down list below.";
        Label7->Caption = "&Nym";
        return;
     }

     if (ResendBtn->Checked)
     {
        CancelBtn->Caption = "Cancel";
        Caption = cap + " - Send Config Message Again";
        BackBtn->Enabled = true;
        NextBtn->Enabled = NymsResendBox->ItemIndex>=0;
        NextBtn->Caption = Finish;
        Notebook1->PageIndex = resend;
        return;
     }

     if (DeleteBtn->Checked)
     {
        //if (NymsDeleteBox->ItemIndex>=0)
        //    NymsDeleteBox->TopIndex = NymsDeleteBox->ItemIndex;
        CancelBtn->Caption = "Cancel";
        Caption = cap + " - Delete Nym";
        BackBtn->Enabled = true;
        NextBtn->Enabled = NymsDeleteBox->ItemIndex>=0;
        NextBtn->Caption = Finish;
        Notebook1->PageIndex = Delete;
        ActiveControl = NymsDeleteBox;
        return;
     }

     if (RetiredBtn->Checked)
     {
        CancelBtn->Caption = "Cancel";
        Caption = cap +" - Retired Nyms";
        BackBtn->Enabled = true;
        NextBtn->Enabled = NymsRetireBox->ItemIndex>=0;
        NextBtn->Caption = Finish;
        Notebook1->PageIndex = retire;
        return;
     }

     if (ViewNymBtn->Checked)
     {
        CancelBtn->Caption = "Close";
        Caption = cap +" - View Profile";
        BackBtn->Enabled = true;
        NextBtn->Enabled = false;
        Notebook1->PageIndex = viewnym;
        ViewNym->ItemIndex = ViewNym->Items->IndexOf(NYMBox->Text);
        ViewNymChange(NULL);
        return;
     }
  }
  if (validate && idx==nymname)
  {
     if (CreateBtn->Checked)
     {
        if (!validaddress(NYM->Text))
        {
           MsgBoxHwnd(Handle,
             "A valid e-mail address is required to proceed!",
             "Address Required",
              MB_OK);
           ActiveControl = NYM;
           return;
        }
        if (NYMBox->Items->IndexOf(NYM->Text)>=0)
        {
           MsgBoxHwnd(Handle,
              "The nym you have entered already exists!",
              "Can't Create",
               MB_OK);
           ActiveControl = NYM;
           return;
        }
        if (nymservers->IndexOf(GetToken(1,NYM->Text,"@"))<0)
        {
           MsgBoxHwnd(Handle,
              s("Your nym's address must include a valid nym domain.\n")+
              s("Currently these are:\n\n")+
              s(nymservers->Text),
              "Can't Create",
               MB_OK);
           ActiveControl = NYM;
           return;
        }
     }
     if (ModifyBtn->Checked)
     {
        if (!validaddress(NYMBox->Text))
        {
           MsgBoxHwnd(Handle,
             "A valid e-mail address is required to proceed!",
             "Address Required",
              MB_OK);
           ActiveControl = NYMBox;
           return;
        }
     }
  }

  if (validate && idx==pgpkey && PgpKey->Text.IsEmpty())
  {
     MsgBoxHwnd(Handle,
        "Your nym requires a PGP key assigned to proceed!",
        "PGP Key Required",
         MB_OK);
     ActiveControl = PgpKey;
     return;
  }

  if (validate && idx==blocks && !validreplyblock(ReplyBlock))
  {
     MsgBoxHwnd(Handle,
        "Your reply block is not correct. Please review your format.",
        "Reply Block Error",
         MB_OK);
     ActiveControl = ReplyBlock;
     return;
  }

  CancelBtn->Caption = "Cancel";
  if (idx==nymname)
  {
     SetLabel1Caption(NYM->Text);
     if (PgpKey->Text.IsEmpty()) GetPgpKeyFromEmailAddress();
  }
  if (idx==pgpkey) SetFingerKeyFromInput();
  if (idx==blocks)
  {
     bool mod = ReplyBlock->Modified;
     if (!ReplyBlocksValid(this,ReplyBlock->Lines)) return;
     ReplyBlock->Modified = mod;
     FillReviewFromInput();
  }
  if (idx<review) idx++; else MyBeep(0);
  if (idx==review)
  {
     NextBtn->Caption = Finish;
     Label20->Caption = "Clicking 'Finish' now will prepare and open your Nym-Config message.";
     if (ModifyBtn->Checked)
        Label20->Caption = Label20->Caption +
        " Reply blocks will be included ONLY if modified. Your PGP key will be included only if reply blocks are.";
  }
  BackBtn->Enabled = idx>start ? true:false;
  Notebook1->PageIndex = idx;
  if (idx==blocks) ActiveControl = ReplyBlock;
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::BackBtnClick(TObject *Sender)
{
  int idx=Notebook1->PageIndex;
  if (idx==resend && ResendBtn->Checked)
  {
     CancelBtn->Caption = "Close"; Caption = cap;
     NextBtn->Caption = "Next";
     NextBtn->Enabled = true;
     BackBtn->Enabled = false;
     Notebook1->PageIndex = start;
     return;
  }
  if (idx==Delete && DeleteBtn->Checked)
  {
     CancelBtn->Caption = "Close"; Caption = cap;
     NextBtn->Caption = "Next";
     NextBtn->Enabled = true;
     BackBtn->Enabled = false;
     Notebook1->PageIndex = start;
     return;
  }
  if (idx==retire && RetiredBtn->Checked)
  {
     CancelBtn->Caption = "Close"; Caption = cap;
     NextBtn->Caption = "Next";
     NextBtn->Enabled = true;
     BackBtn->Enabled = false;
     Notebook1->PageIndex = start;
     return;
  }
  if (idx==viewnym && ViewNymBtn->Checked)
  {
     CancelBtn->Caption = "Close"; Caption = cap;
     NextBtn->Caption = "Next";
     NextBtn->Enabled = true;
     BackBtn->Enabled = false;
     Notebook1->PageIndex = start;
     return;
  }
  if (idx==review) NextBtn->Caption = "Next";
  if (idx==start || idx==nymname) Caption = cap;
  if (idx==nymname) Label1->Caption = cap1;
  if (idx>start) idx--; else MyBeep(0);
  BackBtn->Enabled = idx>start ? true:false;
  CancelBtn->Caption = idx>start ? "Cancel":"Close";
  Notebook1->PageIndex = idx;
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::ClrNymCommands()
{
   for (int i=0; i<nymcmds->Count; i++)
      delete (TCheckBox*)nymcmds->Objects[i];
   nymcmds->Clear();
 }
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::SetNymCommands(TStrings *cmds)
{
   AnsiString Cap,c;
   TCheckBox *chkbox;
   if (nymcmds!=cmds) nymcmds->Text = cmds->Text;
   TrimNullsEnd(nymcmds);
   if (!nymcmds->Count) nymcmds->CommaText = DefNymCmds;
   int X=15,x=15,y=20; for (int i=0; i<nymcmds->Count; i++)
   {
      chkbox = new TCheckBox((TComponent*)NULL);
      chkbox->Parent = (TWinControl*)GroupBox1;//(TWinControl*)Notebook1->Pages->Objects[command];
      nymcmds->Objects[i] = chkbox;
      Cap = nymcmds->Strings[i];
      c = Cap.SubString(1,1);
      if (c=="+" || c=="-")
      {
         chkbox->Checked = c=="+";
         Cap.Delete(1,1);
      }
      //if (Cap.LowerCase()=="fixedsize")  // fixedsize not supported yet
      //{
      //   chkbox->Enabled = false;
      //   chkbox->Checked = false;
      //}
      if (Cap=="fingerkey") fingerkey = chkbox;
      chkbox->Caption = Cap;
      chkbox->Left = x;
      chkbox->Top = y;

      if (x>260)
      {
         x = X; y += 24;
         continue;
      }
      x += 90;
   }
//sm(nymcmds->Text);
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::ReinstateBtnClick(TObject *Sender)
{
   Label13->Caption =
      s("Clicking 'Finish' will prepare and open a Create-Nym message for the ")+
      s("selected nym and add that nym profile back to the active nyms list.");
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::RemoveBtnClick(TObject *Sender)
{
   Label13->Caption =
      "Clicking 'Finish' will remove the nym profile permanently from the system.";
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::ReDelBtnClick(TObject *Sender)
{
   Label13->Caption =
      s("If you have deleted a nym but received no acknowlegment from the ")+
      s("nym-server, resending the delete message may be needed. Clicking ")+
      s("'Finish' now will prepare and queue another Delete-Nym message.");
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::ResendBoxClick(TObject *Sender)
{
   RichEdit2->Lines->Text =
      s("Clicking 'Finish' now will re-open the last nym-config message you sent ")+
      s("for the selected nym. The message will be the original clear-text.");
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::ReplayBoxClick(TObject *Sender)
{
   RichEdit2->Lines->Text =
      s("Clicking 'Finish' now will re-open the last nym-config message you sent ")+
      s("for the selected nym. Replay utilizes the previously encrypted message ")+
      s("over again.");
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrCancel && Notebook1->PageIndex>start && !ViewNymBtn->Checked)
   {
      CanClose = false;
      switch (CancelNymOperation(this))
      {
         case mrAbort: CanClose = true; break;
         case mrYes: ReturnHome(); break;
         case mrNo: return;
      }
   }
   PutAppIni(LastNymProfileKey,NYMBox->Text);
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::SetInputFromNym(AnsiString nym)
{
   GetAppData(profile,NymProfilesKey+PS+nym);
   SetInputFromProfile(profile);
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::SetInputFromProfile(TNymProfile *Profile)
{
   //ClearAll();
   // name and address
   NYM->Text = profile->nym();
   Name->Text = profile->nymname(); Name->Modified = false;
   // pgp key
   int idx = PgpKey->Items->IndexOf(profile->nympgpkey());
   //if (idx<0) idx = PgpKey->Items->Add(profile->nympgpkey());
   PgpKey->ItemIndex = idx;
   // reply block
   ReplyBlock->Lines->Text = profile->nymreplyblocks();
   TrimNullsStart(ReplyBlock->Lines);
   ReplyBlock->Modified = false;
   // commands
   TStringList *cmds = new TStringList();
   AnsiString tmp,cmd = profile->nymcommands();
   int pos=0; while ((tmp=GetToken(pos++,cmd," "))!="") cmds->Add(tmp);
   SetNymCommands(cmds);
   delete cmds;
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::NYMBoxChange(TObject *Sender)
{
   SetLabel1Caption(NYMBox->Text);
   SetInputFromNym(NYMBox->Text);
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::ReturnHome()
{
   CancelBtn->Caption = "Close";
   NextBtn->Caption = "Next";
   NextBtn->Enabled = true;
   BackBtn->Enabled = false;
   Notebook1->PageIndex = start;
}
//---------------------------------------------------------------------------
bool __fastcall TNymWizDlg::CheckNymPgpKeyNotMissing()
{
   if (PgpKey->ItemIndex<0)
   {
      if(!RestoreNymPGPkeys(this,profile,pubkeys,seckeys)) return false;
      SetNymPgpKeyUserIds();
      SetInputFromNym(NYM->Text);
      AppProcessMessages();
      ((TForm*)Owner)->Perform(WM_UPDATEPGPKEYWIN,0,0);
   }
   return true;
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::NymsDeleteBoxClick(TObject *Sender)
{
   NextBtn->Enabled = true;
   SetInputFromNym(NymsDeleteBox->Items->Strings[NymsDeleteBox->ItemIndex]);
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::NymsResendBoxClick(TObject *Sender)
{
   NextBtn->Enabled = true;
   SetInputFromNym(NymsResendBox->Items->Strings[NymsResendBox->ItemIndex]);
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::NymsRetireBoxClick(TObject *Sender)
{
   NextBtn->Enabled = true;
   AnsiString nym = NymsRetireBox->Items->Strings[NymsRetireBox->ItemIndex];
   GetAppData(profile,NymRetiredsKey+PS+nym);
   SetInputFromProfile(profile);
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::NYMChange(TObject *Sender)
{
   int idx,pos;
   Name->Clear();
   if ((idx=NYM->Items->IndexOf(NYM->Text))>=0) NYM->ItemIndex = idx;
   if (NYM->ItemIndex>=0)
   {
      AnsiString uid;
      for (int i=0; i<userids->Count; i++)
         if (userids->Strings[i].Pos(NYM->Text)>0)
         {
            uid = userids->Strings[i]; pos = uid.Pos("<");
            if (pos>1) Name->Text = uid.SubString(1,pos-1).Trim();
         }
   }
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::RemailerBtnClick(TObject *Sender)
{
   AnsiString addr = GetRemailerAddress(this);
   if (!addr.IsEmpty()) ReplyBlock->SelText = addr;
   ActiveControl = ReplyBlock;
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::PopEditDirectivesItemClick(TObject *Sender)
{
   TStringList *dirs = new TStringList();
   GetCpkDirectives(dirs);
   if (EditCpkDirectives(this,dirs))
   {
      PutAppData(CpkDirectivesKey,dirs);
      LoadCpkDirectivesMenu();
   }
   delete dirs;
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::PopEditHeadersItemClick(TObject *Sender)
{
   TStringList *hdrs = new TStringList();
   GetCpkHeaders(hdrs);
   if (EditCpkHeaders(this,hdrs))
   {
      PutAppData(CpkHeadersKey,hdrs);
      LoadCpkHeadersMenu();
   }
   delete hdrs;
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::EditTemplatesItemsClick(TObject *Sender)
{
   TStringList *temps = new TStringList();
   GetAppData(temps,NymRBTempsKey);
   if (EditRBTemplates(this,temps))
   {
      PutAppData(NymRBTempsKey,temps);
      LoadRBTemplatesMenu();
   }
   delete temps;
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::BiggerBtn1Click(TObject *Sender)
{
   EditReplyBlocks(this,ReplyBlock->Lines);
   Application->OnHint = ShowHint;
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::EditCmdsBtnClick(TObject *Sender)
{
   TStringList *cmds = new TStringList();
   GetAppData(cmds,NymCommandsKey);
   if (EditNymCommands(this,cmds))
      PutAppData(NymCommandsKey,cmds);
   delete cmds;
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::ViewNymChange(TObject *Sender)
{
   if (!ViewNym->Text.IsEmpty())
   {
      SetRedraw(this,0);
      TStrings *lines = new TStringList();
      GetAppData(lines,NymProfilesKey+PS+ViewNym->Text);
      // remove second key block
      while (lines->Count && lines->Strings[lines->Count-1]!=BeginPgpPubKeyBlock)
         lines->Delete(lines->Count-1);
      if (lines->Count) lines->Delete(lines->Count-1);
      // remove first key block
      while (lines->Count && lines->Strings[lines->Count-1]!=BeginPgpPubKeyBlock)
         lines->Delete(lines->Count-1);
      if (lines->Count) lines->Delete(lines->Count-1);
      // double space everything until replyblock
      for (int i=0; i<lines->Count; i++)
      {
         if (lines->Strings[i].Pos("Reply-Block:")==1) break;
         lines->Strings[i] = lines->Strings[i] +"\r\n";
      }
      // separate replyblocks with space
      for (int i=0; i<lines->Count; i++)
      {
         if (lines->Strings[i].Trim().Pos("Reply-Block:")==1)
             lines->Strings[i] = "\r\n"+lines->Strings[i].Trim();
      }
      AnsiString text = lines->Text;
      int pos; while ((pos=text.Pos("\r\n\r\n\r\n"))>0) text.Delete(pos,2);
      ViewProfile->Lines->Text = text;
      delete lines;
      AppProcessMessages();
      SetRedraw(this,1);
      AppProcessMessages();
   }
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::RemailersBtnClick(TObject *Sender)
{
   AnsiString addr = GetRemailerAddress(this);
   if (!addr.IsEmpty()) ReplyBlock->SelText = addr;
   ActiveControl = ReplyBlock;
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::HelpBtnClick(TObject *Sender)
{
   AnsiString topics = "NymWizard\nNyms\nNewMessageNym\nMessageInNym";
   switch(Notebook1->PageIndex)
   {
      case start  : OpenHelp(topics,"Nym Wizard","Main Menu"); break;
      case nymname: OpenHelp(topics,"Nym Wizard","Nym Address and Full Name"); break;
      case pgpkey : OpenHelp(topics,"Nym Wizard","Your Nym's PGP Key"); break;
      case command: OpenHelp(topics,"Nym Wizard","Nym-Commands"); break;
      case blocks : OpenHelp(topics,"Nym Wizard","Reply Block Editor"); break;
      case review : OpenHelp(topics,"Nym Wizard","Review Your Configuration"); break;
      case Delete : OpenHelp(topics,"Nym Wizard","Deleting A Nym Account"); break;
      case retire : OpenHelp(topics,"Nym Wizard","Retiring Nyms"); break;
      case resend : OpenHelp(topics,"Nym Wizard","Sending Your Nym-Config Again"); break;
      case viewnym: OpenHelp(topics,"Nym Wizard","Viewing Nym Profiles"); break;
   }
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::NymServerBtnClick(TObject *Sender)
{
   if (EditNymServers(this,nymservers))
   {
      PutAppData(NymServersKey,nymservers);
      GetNymServers(nymservers);
   }
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::FormKeyDown(TObject *Sender, WORD &Key,
	TShiftState Shift)
{
   if (Key==VK_SHIFT) Shifted = true;
}
//---------------------------------------------------------------------------
void __fastcall TNymWizDlg::FormKeyUp(TObject *Sender, WORD &Key,
	TShiftState Shift)
{
   if (Key==VK_SHIFT) Shifted = false;
}
//---------------------------------------------------------------------------
